<?
class FTPExplorer {
  function browseFTPServer ($hostname) {
     $this->_browseTree ($hostname);
  }

  function _browseTree ($hostname, $path = '') { global $indexer, $wget;
     $file_names = $wget->ftpFileList ($hostname, $path);

     if (!$file_names) return;
     if (!count ($file_names)) return;

     for ($cntr = 0; $cntr < count ($file_names); $cntr ++) {
          $name = $file_names[$cntr]->{'name'};
          if (!$name || $name == '.' || $name == '..') continue;

          if ($file_names[$cntr]->{'mark'} == 'D') {
              $next_path = $path.'/'.$name;
              $this->_browseTree ($hostname, $next_path);
              continue;
          }

          if (!$this->_fileIsAcceptable ($path, $name)) continue;

          $file_size = $file_names[$cntr]->{'size'};

          $media_type = $this->_mediaType ($name);
          if (!$media_type) continue;

          $description = '';

          $description->{'server'} = $hostname;
          $description->{'path'} = $path;
          $description->{'name'} = $name;
          $description->{'size'} = $file_size;
          $description->{'type'} = $media_type;

          $indexer->makeSearchIndex ($description);

          $description->{'type'} = 'D';

          $words = split ('/', $path);
          if (count ($words) <= 1) continue;

          $description->{'name'} = $words[count ($words) - 1];
          array_splice ($words, count ($words) - 1); 
          $description->{'path'} = join ('/', $words);
          unset ($words);

          $indexer->makeSearchIndex ($description);

          unset ($description);
     }
  }

  function _fileIsAcceptable ($path, $name) { global $methods;
     $path = $methods->lowerCase ($path);
     $name = $methods->lowerCase ($name);

     if (strpos (' '.$name, ':') || strpos (' '.$name, 'no such file')) return 0;

     if (strpos (' '.$path, 'xxx')  || strpos (' '.$name, 'xxx'))  return 0;
     if (strpos (' '.$path, 'porn') || strpos (' '.$name, 'porn')) return 0;
     if (strpos (' '.$path, 'gay')  || strpos (' '.$name, 'gay'))  return 0;
     if (strpos (' '.$path, 'lesb') || strpos (' '.$name, 'lesb')) return 0;

     if (strpos ($name, '.') && !$this->_mediaType ($name)) return 0;

     return 1;
  }

  function _mediaType ($name) { global $methods;
     $ext = trim ($methods->lowerCase (substr ($name, strrpos ($name, '.'))));
     if (strlen ($ext) > 4) $ext = '';

     if (!$ext) return '';

     {
      if ($ext == '.mp3')  return 'A';
      if ($ext == '.mpc')  return 'A';
      if ($ext == '.ogg')  return 'A';
      if ($ext == '.wma')  return 'A';
     }

     {
      if ($ext == '.mid')  return 'M';
      if ($ext == '.midi') return 'M';

      if ($ext == '.mod')  return 'M';
      if ($ext == '.s3m')  return 'M';
      if ($ext == '.amf')  return 'M';
      if ($ext == '.xm')   return 'M';
     }

     {
      if ($ext == '.mpg')  return 'V';
      if ($ext == '.mpeg') return 'V';
      if ($ext == '.avi')  return 'V';
      if ($ext == '.wmv')  return 'V';
     }

     {
      if ($ext == '.swf')  return 'F';
     }

     {
      if ($ext == '.zip')  return 'Z';
      if ($ext == '.rar')  return 'Z';
      if ($ext == '.arj')  return 'Z';
      if ($ext == '.ace')  return 'Z';
      if ($ext == '.arc')  return 'Z';
      if ($ext == '.lzh')  return 'Z';
      if ($ext == '.ice')  return 'Z';
      if ($ext == '.ha')   return 'Z';
      if ($ext == '.uc2')  return 'Z';
      if ($ext == '.zoo')  return 'Z';

      if ($ext == '.shk')  return 'Z';
      if ($ext == '.sdk')  return 'Z';
      if ($ext == '.bxy')  return 'Z';
      if ($ext == '.hqx')  return 'Z';

      if ($ext == '.z')    return 'Z';
      if ($ext == '.gz')   return 'Z';
      if ($ext == '.tgz')  return 'Z';
      if ($ext == '.bz2')  return 'Z';

      if ($ext == '.iso')  return 'Z';
      if ($ext == '.nrg')  return 'Z';
      if ($ext == '.bin')  return 'Z';
      if ($ext == '.cif')  return 'Z';

      if ($ext == '.jar')  return 'Z';
      if ($ext == '.exe')  return 'Z';
     }

     return '';
  }
}
?>