<?
/**
 *       SQL       .
 */

class AbstractPages {

   function AbstractPages ($num_rows, $rows_on_page, $sql_server) { global $page, $query;
        $this->{'data'}->{'rows_on_page'} = $rows_on_page;
        $this->{'data'}->{'min_rows_on_page'} = round ($rows_on_page / 4) + 1;

        $this->{'data'}->{'num_rows'} = $num_rows;
        $max_page = $this->_calculateMaxPageNumber (); 

        if (!isset ($page) || $page === '' || 
            $page < 0 || $page > $max_page ||
            strval ((int) $page) != strval ($page)) $page = $max_page;

        $this->{'data'}->{'page'} = $page;

        $this->{'data'}->{'sql_server'} = $sql_server;
        $this->{'data'}->{'query_object'} = $query;
   }

   function setAnchors ($prev, $next) {
        if (file_exists ($prev) && file_exists ($next)) {
            $this->{'data'}->{'prev_anchor'} = $prev;
            $this->{'data'}->{'next_anchor'} = $next;
        }
   }

   function prevAnchor ($script_name = '') { global $PHP_SELF;
        if (!$script_name) $script_name = $PHP_SELF;

        $anchor_string = '';

        $max_page = $this->_calculateMaxPageNumber ();

        if ($this->{'data'}->{'page'} >= 0 && $this->{'data'}->{'page'} < $max_page) {
            $previous_page = $this->{'data'}->{'page'} + 1; $previous_link = 'page='.($previous_page);
            $anchor_string .= '<a href="'.$script_name.$this->{'data'}->{'query_object'}->stringFor ('page').$previous_link.'">';

            if ($this->{'data'}->{'prev_anchor'}) $anchor_string .= $methods->txt ($this->{'data'}->{'prev_anchor'});
            else $anchor_string .= '<b>&lt;&lt;</b>';

            $anchor_string .= '</a>';
        }

        return $anchor_string;
   }

   function nextAnchor ($script_name = '') { global $PHP_SELF;
        if (!$script_name) $script_name = $PHP_SELF;

        $anchor_string = '';

        $max_page = $this->_calculateMaxPageNumber ();

        if ($this->{'data'}->{'page'} > 0 && $this->{'data'}->{'page'} <= $max_page) {
            $next_page = $this->{'data'}->{'page'} - 1; $next_link = 'page='.($next_page);
            $anchor_string .= '<a href="'.$script_name.$this->{'data'}->{'query_object'}->stringFor ('page').$next_link.'">';

            if ($this->{'data'}->{'next_anchor'}) $anchor_string .= $methods->txt ($this->{'data'}->{'next_anchor'});
            else $anchor_string .= '<b><blink>&gt;&gt;</blink></b>';

            $anchor_string .= '</a>';
        }

        return $anchor_string;
   }

   function pageAnchors ($script_name = '', $space = '&nbsp;&nbsp;&nbsp;') { global $PHP_SELF;
        if (!$script_name) $script_name = $PHP_SELF;

        $anchor_string = "\n";

        $max_page = $this->_calculateMaxPageNumber ();

        if ($this->{'data'}->{'page'} >= 0 && $this->{'data'}->{'page'} <= $max_page) {
            for ($cntr = 0; $cntr <= $max_page; $cntr ++) {
                 $html_page_number = $cntr + 1;
                 $link_page_number = $max_page - $cntr;

                 $limits = $this->_limits ($link_page_number);
                 $limit_1 = $limits->{'start'} + 1;
                 $limit_2 = $limits->{'start'} + $limits->{'rows'};

                 if (trim ($anchor_string)) $anchor_string .= $space;

                 if ($link_page_number != $this->{'data'}->{'page'}) {
                     $anchor_string .= '<a href="'.$script_name.$this->{'data'}->{'query_object'}->stringFor ('page').'page='.$link_page_number.'" title="'.$limit_1.' - '.$limit_2.'">';
                     $anchor_string .= $html_page_number;
                     $anchor_string .= '</a>'."\n";
                 } else {
                     $anchor_string .= '<b>';
                     $anchor_string .= $html_page_number;
                     $anchor_string .= '</b>'."\n";
                 }
            }
        }

        return $anchor_string;
   }

   function _limits ($current_page = -1) {
        $limits = '';

        $max_page = $this->_calculateMaxPageNumber ();

        if ($current_page >= 0 && $current_page <= $max_page) {
            $remainder = $this->{'data'}->{'num_rows'} - $this->{'data'}->{'rows_on_page'} * $max_page;
            if ($remainder < $this->{'data'}->{'min_rows_on_page'}) $remainder = $this->{'data'}->{'min_rows_on_page'};

            if ($current_page == $max_page) {
                $start = 0; $rows = $remainder;
            }

            if ($current_page != $max_page) {
                $rows = $this->{'data'}->{'rows_on_page'};
                $start = $remainder + $rows * ($max_page - $current_page - 1);
            }

            $limits->{'start'} = $start;
            $limits->{'rows'} = $rows;
        }

        return $limits;
   }

   function _calculateMaxPageNumber () {
        $max_page = round ($this->{'data'}->{'num_rows'} / $this->{'data'}->{'rows_on_page'}) - 1;
        if ($max_page == -1) $max_page = 0;

        return $max_page;
   }
}

class SQLPages extends AbstractPages {
   function SQLPages ($num_rows, $rows_on_page = 20) { global $config;
        $sql_server = 'mysql';
        if (isset ($config) && $config->param ('dbms')) $sql_server = $config->param ('dbms');

        $this->AbstractPages ($num_rows, $rows_on_page, $sql_server);
   }

   function getSQLLimits () {
        $limits = $this->_limits ($this->{'data'}->{'page'});
        if (!$limits) return ' LIMIT 0';

        $start = $limits->{'start'};
        $rows = $limits->{'rows'};

        $sql_server = $this->{'data'}->{'sql_server'};
        if ($sql_server == 'pgsql') return ' LIMIT '.$rows.' OFFSET '.$start;

        return ' LIMIT '.addslashes ($start).', '.addslashes ($rows);
   }
}

class TreePages extends AbstractPages {
   function TreePages ($num_rows, $rows_on_page = 20) {
        $this->AbstractPages ($num_rows, $rows_on_page, '');
   }

   function reduceNodeArray ($nodes) {
        $limits = $this->_limits ($this->{'data'}->{'page'});
        if (!$limits) return $nodes;

        $start = $limits->{'start'};
        $rows = $limits->{'rows'};

        return array_slice ($nodes, $start, $rows);
   }
}
?>