<?
/**
 *     WGet
 */

class WGetRunner {
   function download ($location, $type = 'text/html') { global $url_parser;
      if (isset ($url_parser)) $location = $url_parser->link ($location);
      if (!$location) return '';

      if (!$this->_contentTypeIsCorrect ($location, $type)) return '';

      $temp_name = $this->_tmpName ();

      $command = $this->_exeName ().
                 ' --quiet'.
                 ' --output-document='.$temp_name.
                 ' '.$location;

      exec ($command); if (file_exists ('core')) unlink ('core');

      $data = '';

      if (file_exists ($temp_name)) {
          if (filesize ($temp_name)) {
              $file = fopen ($temp_name, 'r');
              $data = fread ($file, filesize ($temp_name));
              fclose ($file); unset ($file);
          }

          unlink ($temp_name); unset ($temp_name);
      }

      return $data;
   }

   function _contentTypeIsCorrect ($location, $required_type) {
      if (!$required_type) return 0;

      $command = $this->_exeName ().
                 ' --spider'.
                 ' --server-response'.
                 ' --output-document='.$this->_stdoutName ().
                 ' '.$location.
                 ' 2>&1';

      $output = array ();
      exec ($command, $output); if (file_exists ('core')) unlink ('core');

      if (!$output) return 0;
      if (!count ($output)) return 0;

      $data = join ("\n", $output);

      if (strpos ($data, $required_type)) return 1;

      return 0;
   }

   function wgetIsInstalled () {
      $rc = 0;
      passthru ($this->_exeName ().' >'.$this->_nullFile ().' 2>'.$this->_nullFile (), $rc);
      if ($rc == 1 || $rc == 127) return 1;

      return 0;
   }

   function _tmpName () {
       return tempnam ('/tmp', 'wget-');
   }

   function _stdoutName () {
       return '-';
   }

   function _nullFile () {
       if (is_dir ('C:\\')) return 'NUL';
       else return '/dev/null';
   }

   function _exeName () { global $config;

       $wget_name = 'wget';

       if (isset ($config)) { 
           $name = $config->param ('exec.wget_name');
           if ($name) $wget_name = $name;
       }

       return $wget_name;
   }

  function ftpFileList ($hostname, $path = '') {

     $wget_exe_name = $this->_exeName ();
     $wait_ten_seconds = '--timeout=10';
     $only_two_retries = '--tries=2';
     $output_to_stdout = '--output-document='.$this->_stdoutName ();

     $path = $this->_ftpEncodeWGetPathLine ($path);
     $location = '"ftp://'.str_replace ('//', '/', $hostname.'/'.$path).'/"';

     $command = $wget_exe_name.
                ' --quiet'.
                ' '.$wait_ten_seconds.
                ' '.$only_two_retries.
                ' '.$output_to_stdout.
                ' '.$location;

     $output = array ();
     exec ($command, $output); if (file_exists ('core')) unlink ('core');

     if (!$output) return '';
     if (!count ($output)) return '';

     $files = array ();

     for ($cntr = 0; $cntr < count ($output); $cntr ++) {
          $mark = strtolower (substr ($output[$cntr], 0, strpos ($output[$cntr], '<')));
          if (strpos ($mark, ' directory ')) $mark = 'D';
          if (strpos ($mark, ' file ')) $mark = 'F';
          if (strlen ($mark) != 1) continue;

          $line = $output[$cntr];

          if (strpos (' '.$line, '<a href="ftp://'.$hostname)) {
              $name = $line;

              $name = substr ($name, strpos ($name, 'ftp://'));
              $name = substr ($name, 0, strpos ($name, '">'));
              $name = $this->_ftpDecodeWGetLine ($name);

              $name = str_replace (dirname ($name), '', $name);
              $name = str_replace ('/', '', $name);

              $size = '';
              if (strpos ($line, ' bytes)')) {
                  $size = $line;

                  $size = substr ($size, strpos ($size, '</a>'));
                  $size = substr ($size, strpos ($size, '('));
                  $size = substr ($size, 1, strpos ($size, ')') - 1);

                  $size = str_replace (' bytes', '', $size);
                  $size = str_replace (',', ' ', $size);
              }

              $description = '';
              $description->{'name'} = $name;
              $description->{'size'} = $size;
              $description->{'mark'} = $mark;
              $files[] = $description;
              unset ($description);
          }
     }

     if (!count ($files)) return '';

     return $files;
  }

  function _ftpEncodeWGetPathLine ($string)  {
     $words = explode ('/', $string);
     for ($word_cntr = 0; $word_cntr < count ($words); $word_cntr ++) {
          $encoded_word = '';
          for ($char_cntr = 0; $char_cntr < strlen ($words[$word_cntr]); $char_cntr ++) {
               $encoded_word .= '%'.dechex (ord ($words[$word_cntr][$char_cntr]));
          }
          $words[$word_cntr] = $encoded_word;
     }
     $string = implode ('/', $words);

     return $string;
  }

  function _ftpDecodeWGetLine ($string)  {
     $trans_tbl = get_html_translation_table (HTML_ENTITIES, ENT_QUOTES);
     $trans_tbl = array_flip ($trans_tbl);
     $ret = strtr ($string, $trans_tbl);

     return preg_replace('/&#(\d+);/me', "chr('\\1')", $ret);
  }
}

$wget = new WGetRunner ();
?>